import 'package:audioplayers/audioplayers.dart';
import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:intl/intl.dart';
import 'package:shared_preferences/shared_preferences.dart';
const roomNotConnected = 'You have not connected a valid room';
 final AssetSource incomingChat = AssetSource('enx_flutter_uikit/audio/incoming_chat_message.mp3');
final AssetSource newUser = AssetSource('audio/new_user_enter.mp3');
final AssetSource recordingStart = AssetSource('audio/recording_start.mp3');
final AssetSource recordingStop = AssetSource('audio/recording_stop.mp3');
final AssetSource sessionExpire = AssetSource('audio/session_expiry.mp3');
final AssetSource userExit = AssetSource('audio/user_exit.mp3');
String getCurrentTime() {
  return DateFormat('kk:mm:ss').format(DateTime.now()).toString();
}
void showToastMessage(String message) {
  Fluttertoast.showToast(
      msg: message,
      toastLength: Toast.LENGTH_SHORT,
      gravity: ToastGravity.CENTER,
      backgroundColor: Colors.red,
      textColor: Colors.white,
      fontSize: 16.0);
}
void showToastMessageLong(String message) {
  Fluttertoast.showToast(
      msg: message,
      toastLength: Toast.LENGTH_LONG,
      gravity: ToastGravity.CENTER,
      backgroundColor: Colors.red,
      textColor: Colors.white,
      fontSize: 16.0);
}


Future<SharedPreferences> geSharePreference() async{

  return await SharedPreferences.getInstance();
}
AudioPlayer player = AudioPlayer();
void playAudio(Source audioPath) async {
//audioPath.setOnPlayer(player);
  print("dinesh $audioPath");
  player.play(audioPath);


}
void stopAudio(){
 // player.stop();

}

/*
Future<bool> handlePermissionsForCall(BuildContext context) async {
  Map<Permission, PermissionStatus> statuses = await [
    Permission.camera,
    Permission.microphone,
    Permission.storage,
  ].request();
/*
Future<bool> handlePermissionsForCall(BuildContext context) async {
  Map<Permission, PermissionStatus> statuses = await [
    Permission.camera,
    Permission.microphone,
    Permission.storage,
  ].request();

  if (statuses[Permission.storage]!.isPermanentlyDenied) {
    showCustomDialog(context, "Permission Required",
        "Storage Permission Required for Video Call", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  } else if (statuses[Permission.camera]!.isPermanentlyDenied) {
    showCustomDialog(context, "Permission Required",
        "Camera Permission Required for Video Call", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  } else if (statuses[Permission.microphone]!.isPermanentlyDenied) {
    showCustomDialog(context, "Permission Required",
        "Microphone Permission Required for Video Call", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  }

  if (statuses[Permission.storage]!.isDenied) {
    return false;
  } else if (statuses[Permission.camera]!.isDenied) {
    return false;
  } else if (statuses[Permission.microphone]!.isDenied) {
    return false;
  }
  return true;
}

void showCustomDialog(BuildContext context, String title, String message,
    Function() okPressed) async {
  showDialog(
    context: context,
    barrierDismissible: false,
    builder: (BuildContext context) {
      // return object of type Dialog

      return AlertDialog(
        shape: const RoundedRectangleBorder(
            borderRadius: BorderRadius.all(Radius.circular(10.0))),
        title: Text(
          title,
          style: const TextStyle(fontFamily: 'WorkSansMedium'),
        ),
        content: Text(
          message,
          style: const TextStyle(fontFamily: 'WorkSansMedium'),
        ),
        actions: <Widget>[
          TextButton(
            child:
            const Text("OK", style: TextStyle(fontFamily: 'WorkSansMedium')),
            onPressed: okPressed,
          ),
        ],
      );
    },
  );
}*/

  if (statuses[Permission.storage]!.isPermanentlyDenied) {
    showCustomDialog(context, "Permission Required",
        "Storage Permission Required for Video Call", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  } else if (statuses[Permission.camera]!.isPermanentlyDenied) {
    showCustomDialog(context, "Permission Required",
        "Camera Permission Required for Video Call", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  } else if (statuses[Permission.microphone]!.isPermanentlyDenied) {
    showCustomDialog(context, "Permission Required",
        "Microphone Permission Required for Video Call", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  }

  if (statuses[Permission.storage]!.isDenied) {
    return false;
  } else if (statuses[Permission.camera]!.isDenied) {
    return false;
  } else if (statuses[Permission.microphone]!.isDenied) {
    return false;
  }
  return true;
}

void showCustomDialog(BuildContext context, String title, String message,
    Function() okPressed) async {
  showDialog(
    context: context,
    barrierDismissible: false,
    builder: (BuildContext context) {
      // return object of type Dialog

      return AlertDialog(
        shape: const RoundedRectangleBorder(
            borderRadius: BorderRadius.all(Radius.circular(10.0))),
        title: Text(
          title,
          style: const TextStyle(fontFamily: 'WorkSansMedium'),
        ),
        content: Text(
          message,
          style: const TextStyle(fontFamily: 'WorkSansMedium'),
        ),
        actions: <Widget>[
          TextButton(
            child:
            const Text("OK", style: TextStyle(fontFamily: 'WorkSansMedium')),
            onPressed: okPressed,
          ),
        ],
      );
    },
  );
}*/

/*Future<bool> handlePermissionsForCall(BuildContext context) async {
  Map<Permission, PermissionStatus> statuses = await [
    Permission.camera,
    Permission.microphone,
    Permission.storage,


  ].request();

  if (statuses[Permission.camera]!.isDenied) {
    showCustomDialog(context, "Permission Required",
        "Camera Permission Required for Video Call", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  } else if (statuses[Permission.microphone]!.isDenied) {
    showCustomDialog(context, "Permission Required",
        "Microphone Permission Required for Video Call", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  }
  else if (statuses[Permission.storage]!.isDenied) {
    showCustomDialog(context, "Permission Required",
        "Storage Permission Required for FIle Sharing", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  }

  else if (statuses[Permission.manageExternalStorage]!.isDenied) {
    showCustomDialog(context, "Permission Required",
        "Manage Storage Permission Required for FIle Sharing", () {
          Navigator.pop(context);
          openAppSettings();
        });
    return false;
  }
  // else if (statuses[Permission.accessMediaLocation]!.isPermanentlyDenied) {
  //   showCustomDialog(context, "Permission Required",
  //       "Access Media Location  Permission Required for FIle Sharing", () {
  //         Navigator.pop(context);
  //         openAppSettings();
  //       });
  //   return false;
  // }
  if (statuses[Permission.camera]!.isDenied) {
    return false;
  } else if (statuses[Permission.microphone]!.isDenied) {
    return false;
  }
  else if(statuses[Permission.storage]!.isDenied) {
     return false;
   }
  else if(statuses[Permission.manageExternalStorage]!.isDenied) {
    return false;
  }
 // }else if(statuses[Permission.accessMediaLocation]!.isDenied){
 // return false;
 // }
  return true;
}*/

void showCustomDialog(BuildContext context, String title, String message,
    Function okPressed) async {
  showDialog(
    context: context,
    barrierDismissible: false,
    builder: (BuildContext context) {
      // return object of type Dialog

      return AlertDialog(
        shape: const RoundedRectangleBorder(
            borderRadius: BorderRadius.all(Radius.circular(10.0))),
        title: Text(
            title
        ),
        content:  Text(
            message

        ),
        actions: <Widget>[
          ElevatedButton(
            child:
            const Text("OK"),
            onPressed: okPressed(),
          ),
        ],
      );
    },
  );
}
