import 'package:http/http.dart' as http;

class Requests {
  final String url;
  final dynamic body;

  Requests({required this.url, this.body});

  Future<http.Response> get() {
    return http.get(Uri.parse(url)).timeout(const Duration(minutes: 2));
  }

  Future<http.Response> post() {
    return http
        .post(Uri.parse(url), body: body)
        .timeout(const Duration(minutes: 2));
  }
}
